/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package xyz.matj1.bp;

import mcdr.objects.impl.ObjectMotionWordSoftAssignment;
import mcdr.sequence.impl.SequenceMocapPoseCoordsL2DTW;
import mcdr.sequence.impl.SequenceMotionWordsDTW;
import mcdr.sequence.impl.SequenceMotionWordsSoftAssignmentDTW;
import mcdr.test.utils.ObjectCategoryMgmt;
import mcdr.test.utils.ObjectMgmt;
import messif.objects.LocalAbstractObject;
import xyz.matj1.bp.Utils.LengthRelation;

import java.io.File;
import java.io.IOException;
import java.time.Duration;
import java.time.Instant;

/**
 * @author Matěj Bagar
 */
public class BPBagar2 {
	/**
	 * The method in which other methods run.
	 *
	 * @param args the command line arguments (ignored)
	 */
	public static void main(String[] args) throws IOException {
		//ObjectMotionWordSoftAssignment.maxPartsToMatch = 6;

		interface ShowGraph {
			void show(String dataPath, Class<? extends LocalAbstractObject> dataClass, String outputPath) throws IOException;
		}

		ShowGraph showQuotientGraph = (dataPath, dataClass, outputDirPath) -> {
			LengthTesting.pairwiseCorrelationShow(
				loadData(dataPath, dataClass),
				LengthRelation.QUOTIENT,
				new File(outputDirPath)
			);
		};

		ShowGraph showKnnLengthGraph = (dataPath, dataClass, outputDirPath) -> {
			var timer = Instant.now();
			LengthTesting.knnLengthTestingShow(
				loadData(dataPath, dataClass),
				new File(outputDirPath)
			);
			System.err.printf(
				"Time to compute KNN for class %s: %d s%n",
				dataClass.getSimpleName(),
				Duration.between(timer, Instant.now()).toSeconds()
			);
		};


		showKnnLengthGraph.show(
						"data/hdm05-annotations_specific-segment80_shift16-coords_normPOS-fps12-quantized-pivots-kmedoids-350.data",
			SequenceMotionWordsDTW.class,
			"output/hard MW KNN graphs"

		);

		showKnnLengthGraph.show(
			"data/class130-actions-coords_normPOS-fps12.data",
			SequenceMocapPoseCoordsL2DTW.class,
			"output/skeleton KNN graphs"
		);

		showKnnLengthGraph.show(
			"data/kmedoids-350-softassign-D20K6.data",
			SequenceMotionWordsSoftAssignmentDTW.class,
			"output/soft MW KNN graphs"
		);

		System.exit(0);
		// The end of ran procedures
		// The rest is there to be available if it was needed later.

		showQuotientGraph.show(
			"data/hdm05-annotations_specific-segment80_shift16-coords_normPOS-fps12-quantized-pivots-kmedoids-350.data",
			SequenceMotionWordsDTW.class,
			"output/hard MW quotient pairwise graphs"
		);

		showQuotientGraph.show(
			"data/class130-actions-coords_normPOS-fps12.data",
			SequenceMocapPoseCoordsL2DTW.class,
			"output/skeleton quotient pairwise graphs"
		);

		showQuotientGraph.show(
			"data/kmedoids-350-softassign-D20K6.data",
			SequenceMotionWordsSoftAssignmentDTW.class,
			"output/soft MW quotient pairwise graphs"
		);
	}

	/**
	 * Loads data for testing motion words (and other sequences) from the file at the given path.
	 *
	 * @param path the given path
	 * @param class_ a class to which the sequences shall be castable
	 * @return an object with motion sequences and their categories
	 * @throws IOException if the file couldn't be read
	 */
	private static ObjectMgmt loadData(
		String path,
		Class<? extends LocalAbstractObject> class_
	) throws IOException {
		ObjectCategoryMgmt mwCategoryMgmt = new ObjectCategoryMgmt();
		ObjectMgmt sequenceMgmt = new ObjectMgmt(mwCategoryMgmt);
		sequenceMgmt.read(class_, path);

		return sequenceMgmt;
	}
}
